<template>
  <div>
    <v-card>
      <v-card-title>
        <v-spacer></v-spacer>
        <v-text-field
          v-model="search"
          append-icon="mdi-magnify"
          label="Buscar"
          single-line
          hide-details
        ></v-text-field>
      </v-card-title>
      <v-data-table
        :headers="headers"
        :items="data"
        :search="search"
        sort-by="limiteInferior"
        class="elevation-1"
      >
        <template v-slot:top>
          <v-toolbar flat>
            <v-tooltip bottom>
              <template v-slot:activator="{ on, attrs }">
                <v-btn
                  fab
                  class="white--text"
                  color="primary"
                  right
                  small
                  v-bind="attrs"
                  v-on="on"
                  @click="addItem"
                  absolute
                >
                  <v-icon>mdi-plus</v-icon>
                </v-btn>
              </template>
              <span>Nuevo rango</span>
            </v-tooltip>
          </v-toolbar>
        </template>
        <template v-slot:item.color="{ item }">
          <v-chip :color="item.color">
            <span :style="'color:' + getContrastColorByBaseColor(item.color)">
              {{ item.color }}
            </span>
          </v-chip>
        </template>
        <template v-slot:item.actions="{ item }">
          <v-icon small class="mr-2" @click="editItem(item)">
            mdi-pencil
          </v-icon>
          <v-icon small @click="deleteItem(item)">
            mdi-delete
          </v-icon>
        </template>
      </v-data-table>
    </v-card>
    <template>
      <v-dialog v-model="isDialogForm" max-width="500px">
        <v-card>
          <v-card-title>
            <strong>{{ formTitle }}</strong>
            <v-icon v-if="editedIndex < 0" right color="primary"
              >mdi-plus</v-icon
            >
            <v-icon v-else right color="primary">mdi-pencil</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text>
            <v-container>
              <v-row>
                <v-col cols="12">
                  <v-text-field
                    v-model.trim="editedItem.descripcion"
                    maxlength="50"
                    :error="$v.editedItem.descripcion.error"
                    hint-align="right"
                    :hint="
                      'CARACTERES RESTANTES ' +
                        serviceCommons.remaningCharacters(
                          editedItem.descripcion,
                          50
                        )
                    "
                    label="Descripción"
                  >
                    <template
                      v-if="$v.editedItem.descripcion.$error"
                      v-slot:append
                    >
                      <v-popover placement="bottom-end" color="red" offset="16">
                        <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                        <template slot="popover">
                          <div
                            @click="$v.editedItem.descripcion.$reset"
                            v-close-popover
                          >
                            <div v-if="!$v.editedItem.descripcion.required">
                              ¡No te olvides de éste campo!
                            </div>
                          </div>
                        </template>
                      </v-popover>
                    </template>
                  </v-text-field>
                </v-col>
                <v-col cols="12" sm="12">
                  <v-menu
                    ref="menu"
                    v-model="menu"
                    :close-on-content-click="false"
                    transition="scale-transition"
                    offset-y
                  >
                    <template v-slot:activator="{ on, attrs }">
                      <v-text-field
                        v-model="editedItem.color"
                        label="Color"
                        readonly
                        v-bind="attrs"
                        v-on="on"
                      >
                        <template v-slot:append>
                          <v-icon :color="editedItem.color">mdi-palette</v-icon>
                        </template>
                      </v-text-field>
                    </template>
                    <v-card class="pa-1 d-flex justify-center">
                      <v-color-picker
                        class="color-picker-custom"
                        :swatches="swatches"
                        show-swatches
                        v-model="editedItem.color"
                      />
                    </v-card>
                  </v-menu>
                </v-col>
                <v-col cols="12" sm="6">
                  <v-text-field
                    v-model.number="editedItem.limiteInferior"
                    v-number:props="{
                      min: 0,
                      max: editedItem.limiteSuperior - 1,
                    }"
                    :error="$v.editedItem.limiteInferior.error"
                    hint-align="right"
                    label="Inferior"
                  >
                    <template
                      v-if="$v.editedItem.limiteInferior.$error"
                      v-slot:append
                    >
                      <v-popover placement="bottom-end" color="red" offset="16">
                        <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                        <template slot="popover">
                          <div
                            @click="$v.editedItem.limiteInferior.$reset"
                            v-close-popover
                          >
                            <div v-if="!$v.editedItem.limiteInferior.required">
                              ¡No te olvides de éste campo!
                            </div>
                            <div v-if="!$v.editedItem.limiteSuperior.max">
                              -¡El valor no puede ser mayor o igual al valor
                              limiteSuperior !
                            </div>
                          </div>
                        </template>
                      </v-popover>
                    </template>
                  </v-text-field>
                </v-col>
                <v-col cols="12" sm="6">
                  <v-text-field
                    v-model.number="editedItem.limiteSuperior"
                    v-number:props="{ min: 0, max: 100 }"
                    :error="$v.editedItem.limiteSuperior.error"
                    hint-align="right"
                    label="Superior"
                  >
                    <template
                      v-if="$v.editedItem.limiteSuperior.$error"
                      v-slot:append
                    >
                      <v-popover placement="bottom-end" color="red" offset="16">
                        <v-icon class color="#fd5151">mdi-alert-circle</v-icon>
                        <template slot="popover">
                          <div
                            @click="$v.editedItem.limiteSuperior.$reset"
                            v-close-popover
                          >
                            <div v-if="!$v.editedItem.limiteSuperior.required">
                              -¡No te olvides de éste campo!
                            </div>
                            <div v-if="!$v.editedItem.limiteSuperior.min">
                              -¡El valor no puede ser menor o igual al valor
                              limiteInferior !
                            </div>
                          </div>
                        </template>
                      </v-popover>
                    </template>
                  </v-text-field>
                </v-col>
              </v-row>
            </v-container>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="close"
                >No, cancelar</v-btn
              >
              <v-btn
                :class="[
                  { desac: this.$v.$invalid },
                  { desac: !hasGlobalChanges },
                ]"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="save"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="isDialogDelete" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh oh...! </strong>
            Borrar rango. Estas totalmente seguro?
            <v-icon right color="orange">mdi-alert</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p v-if="editedItem.descripcion">
              Para confirmar esta acción por favor escribe:
              <br />
              <em
                ><code>{{ editedItem.descripcion }}</code></em
              >
            </p>
            <v-text-field
              v-model="confirmText"
              :autofocus="true"
              label="Confirma con la descripcion del rango"
              flat
              class="mr-2 ml-2"
            />
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                dark
                tile
                depressed
                color="secondary"
                @click="closeDelete"
                >No, cancelar</v-btn
              >
              <v-btn
                :class="[
                  {
                    desac: !(
                      editedItem.descripcion &&
                      confirmText == editedItem.descripcion
                    ),
                  },
                ]"
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="deleteItemConfirm"
                >Si, continuar</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
      <v-dialog v-model="isDialogSave" persistent max-width="600px">
        <v-card>
          <v-card-title>
            <strong>¡Oh...! </strong>
            Todo ha salio bien
            <v-icon right color="green">mdi-check-circle-outline</v-icon>
          </v-card-title>
          <v-divider />
          <v-card-text class="pt-2">
            <p>
              ¡Tus datos fueron guardados!
            </p>
          </v-card-text>
          <v-divider />
          <v-card-actions>
            <div style="width:100%" class="btnCenter">
              <v-btn
                class="ma-2"
                depressed
                dark
                tile
                color="primary"
                @click="isDialogSave = false"
                >Entiendo</v-btn
              >
            </div>
          </v-card-actions>
        </v-card>
      </v-dialog>
    </template>
  </div>
</template>
<style>
.tooltip[aria-hidden="false"] {
  z-index: 9999;
}
.color-picker-custom .v-color-picker__canvas {
  border: 1px solid gray;
}
</style>
<script>
import { required } from "vuelidate/lib/validators";
import store from "@/store";
const axios = store.state.axiosApiLocal;
const serviceCommons = store.state.serviceCommons;
export default {
  descripcion: "Component-Rangos",
  props: ["semaforoIn"],
  data() {
    return {
      isLoadingRangos: false,
      isDialogSave: false,
      rangosSemaforo: [],
      semaforo: null,
      isDialogForm: false,
      menu: false,
      isDialogDelete: false,
      search: null,
      confirmText: null,
      headers: [
        {
          text: "Descripción",
          align: "start",
          sortable: false,
          value: "descripcion",
        },
        { text: "Inferior", sortable: false, value: "limiteInferior" },
        { text: "Superior", sortable: false, value: "limiteSuperior" },
        {
          text: "Color",
          align: "center",
          sortable: false,
          filterable: false,
          value: "color",
        },
        {
          text: "Actions",
          value: "actions",
          filterable: false,
          sortable: false,
        },
      ],
      swatches: [["#D32F2F"], ["#FFD740"], ["#00796B"]],
      data: [],
      rangoBackup: null,
      formTitle: null,
      editedIndex: -1,
      editedItem: {
        descripcion: "",
        limiteInferior: 0,
        limiteSuperior: 0,
        color: "#000000FF",
      },
      defaultItem: {
        descripcion: "",
        limiteInferior: 0,
        limiteSuperior: 0,
        color: "#000000FF",
      },
    };
  },
  validations: {
    editedItem: {
      descripcion: {
        required,
      },
      limiteInferior: {
        required,
        max(value, item) {
          if (value >= item.limiteSuperior) {
            return false;
          }
          return true;
        },
      },
      limiteSuperior: {
        required,
        min(value, item) {
          if (value <= item.limiteInferior) {
            return false;
          }
          return true;
        },
      },
    },
  },
  computed: {
    serviceCommons() {
      return serviceCommons;
    },
    hasGlobalChanges() {
      if (this.rangoBackup) {
        const originalValue = JSON.stringify(this.rangoBackup).replace(
          /"/g,
          ""
        );
        const currentValue = JSON.stringify(this.editedItem).replace(/"/g, "");
        return originalValue !== currentValue;
      } else {
        return this.editedItem.idRango === undefined;
      }
    },
  },
  watch: {
    dialog(val) {
      if (!val) {
        this.close();
      }
    },
    isDialogDelete(val) {
      if (!val) {
        this.closeDelete();
      }
    },
  },
  methods: {
    toRango(rango) {
      return {
        descripcion: "modelo_negocio_accesos_rangos_edicion",
        params: {
          rango: this.serviceCommons.objectToBase64(rango),
        },
      };
    },
    getRangos() {
      this.isLoading = true;
      axios(
        "/sistema-informacion/tablero/semaforos/v1/" +
          this.semaforoIn.idSemaforo +
          "/rangos"
      )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data = data.resultado.rangos;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        })
        .finally(() => {
          this.isLoading = false;
        });
    },
    postRango() {
      let body = {
        ...this.editedItem,
      };
      axios
        .post(
          "/sistema-informacion/tablero/semaforos/v1/" +
            this.semaforoIn.idSemaforo +
            "/rangos",
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.editedItem.idRango = data.resultado.id;
            this.data.push(this.editedItem);
            this.close();
            this.isDialogSave = true;
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    putRango() {
      let body = {
        ...this.editedItem,
      };
      delete body.idRango;
      axios
        .put(
          "/sistema-informacion/tablero/semaforos/v1/" +
            this.semaforoIn.idSemaforo +
            "/rangos/" +
            this.editedItem.idRango,
          body
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            Object.assign(this.data[this.editedIndex], this.editedItem);
            this.isDialogSave = true;
            this.close();
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    deleteRango() {
      axios
        .delete(
          "/sistema-informacion/tablero/semaforos/v1/" +
            this.semaforoIn.idSemaforo +
            "/rangos/" +
            this.editedItem.idRango
        )
        .then((response) => {
          let data = response.data;
          if (data) {
            this.data.splice(this.editedIndex, 1);
            this.closeDelete();
          }
        })
        .catch((error) => {
          if (error.response) {
            console.log(error.response.data);
          }
        });
    },
    getContrastColorByBaseColor(color) {
      return serviceCommons.getContrastColorByBaseColor(color);
    },
    addItem() {
      this.rangoBackup = JSON.parse(JSON.stringify(this.editedItem));
      this.formTitle = "Nuevo rango";
      this.isDialogForm = true;
    },
    editItem(item) {
      this.formTitle = "Modificar rango";
      this.isDialogForm = true;
      this.editedIndex = this.data.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.rangoBackup = JSON.parse(JSON.stringify(this.editedItem));
      this.isDialogForm = true;
    },
    deleteItem(item) {
      this.editedIndex = this.data.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.isDialogDelete = true;
    },
    deleteItemConfirm() {
      this.deleteRango();
    },
    close() {
      this.isDialogForm = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },
    closeDelete() {
      this.isDialogDelete = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
        this.confirmText = null;
      });
    },
    save() {
      if (this.editedIndex > -1) {
        this.putRango();
      } else {
        this.postRango();
      }
    },
  },
  created() {
    this.$v.$touch();
    this.getRangos();
  },
};
</script>
